=== debian/changelog ===
plastimatch (1.6.5+dfsg.1-1) unstable; urgency=medium

  [ Gregory C. Sharp ]
  * New upstream version
  * Use debian libdlib-dev instead of upstream provided dlib
  * Remove patches Fix-test-dependencies.patch and 
    Remove-plm_version.h-from-list-of-installed-files.patch
    which are now fixed upstream

  [ Andreas Tille ]
  * Architecture: any
  * debhelper 10 (no need to specify --parallel any more)
  * d/watch:
     - version=4
     - adapt dversionmangle to separating dfsg and revision number by '.'

 -- Gregory C. Sharp <gregsharp.geo@yahoo.com>  Sun, 04 Dec 2016 17:34:58 -0500

plastimatch (1.6.4+dfsg1-1) unstable; urgency=medium

  * Team upload.

  [ Ghislain Antony Vaillant ]
  * New upstream version 1.6.4+dfsg1
  * Track GitLab tagged releases.
  * Fix FTBFS when testing is performed in parallel.
    New patch Fix-test-dependencies.patch.
    Thanks to Lucas Nussbaum for reporting (Closes: #844942)
  * Cherry-pick upstream patch to fix the install.
    New patch Remove-plm_version.h-from-list-of-installed-files.patch

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 30 Nov 2016 10:48:12 +0000
