=== debian/watch ===
version=4
opts=repacksuffix=+dfsg.1,\
dversionmangle=s/\+(debian|dfsg|ds|deb).*(\d+)?$//,\
filenamemangle=s/.*\.tar\.gz\?ref=v?(\d\S+)/plastimatch-$1\.tar\.gz/g \
https://gitlab.com/plastimatch/plastimatch/tags?sort=updated_desc .*archive\.tar\.gz\?ref=v?(\d\S+)
